
#include <stdio.h>
#include <stdlib.h>
#include <math.h>



//struktura za stablo
typedef struct pokstablo
{
  unsigned int prazan;//da li je cvor prazan ili ne
  unsigned int level;//nivo cvora
  unsigned int nl,nd;//broj dece s leve i desne strane
  unsigned int pl,pd; //broj popunjene dece s leve i desne strane
  unsigned int dd,dl;// dubina sa desne i leve strane
  struct pokstablo *levo,*desno,*gore;//pokazivaci za kretanje kroz stablo
}stablo;


int main(void)
{
	FILE *fp,*fpw;
	unsigned int length,j;
	unsigned int i,prefiks,duz,x,prolaz;
	unsigned char c,tip1,tip2,podtip1,podtip2,l1,l2,l3,l4;
	unsigned int total,granica,pomeraj;
	unsigned int niz1[8],niz2[8];
	unsigned int x1pret,x2pret;
    unsigned int N;//broj nivoa
	stablo *niz,*tren,*novi,*sled;
	stablo *opt,*p;
	unsigned int x1,x2,x3,k,trazi,d;
	unsigned int maska,pommaska;
	unsigned int Nz,Nzprovera,suma;
	unsigned int Nsub;//broj nepraznih podstabala
	unsigned int dmaska;
	unsigned int radi;
    unsigned int sumas, sumap;
    unsigned int no,brpr,ddd,bopt,br32,prazl,prazd; //broj cvorova uklonjen optimizacijom, broj praznih cvorova u tom prolazu, broj za koliko je smanjena dubina
    unsigned int rndbr,simdub,simlist,asimlist,nivo[33],simdeca,asimdeca,listdeca,jedanlist;

	//inicijalizacija pomocnih promenjivih i niza
	x1pret=0x00000000;
	x2pret=0x00000000;
	Nz = 0;//brojac prefiksa
	niz=NULL;//pocetak liste koja sadrzi pokazivace na podstabla

	//kreiranje korena stabla
	novi=malloc(sizeof(stablo));
	novi->desno=NULL;
	novi->levo=NULL;
	novi->gore=NULL;
	novi->level=0;
	novi->nl=0;
	novi->nd=0;
	novi->pl=0;
	novi->pd=0;
	novi->dl=0;
	novi->dd=0;
	novi->prazan=1;
	niz=novi;

	//ucitavanje fajla koji sadrzi tabledump za odredjivanje koliko treba da citamo (postavljanje vrednosti granica)
	total=0;
	fp=fopen("rib.txt","rb");
	fseek(fp, 0L, SEEK_END);
	granica = ftell(fp);
	granica = granica & 0xFFFFFFF0;
	fclose(fp);
	//ponovno ucitavanje istog fajla koji sadrzi tabledump, sada za citanje prefiksa
	fp=fopen("rib.txt","rb");

	fscanf(fp,"%c", &c );
	fscanf(fp,"%c", &c );
	fscanf(fp,"%c", &c );
	fscanf(fp,"%c", &c  );
	//tip i podtip neophodni u identifikaciji IPv4 prefiksa
	fscanf(fp,"%c", &tip1 );
	fscanf(fp,"%c", &tip2 );
	fscanf(fp,"%c", &podtip1 );
	fscanf(fp,"%c", &podtip2 );
	fscanf(fp,"%c", &l1 );
	fscanf(fp,"%c", &l2 );
	fscanf(fp,"%c", &l3 );
	fscanf(fp,"%c", &l4 );

	length=l1;
	length=length<<8 | l2;
	length=length<<8 | l3;
	length=length<<8 | l4;
	total+=length;//duzina jednog zapisa (record) je u length
	i=0;
	br32=0;
	while(c!=EOF)//prolaz kroz fajl i uzimanje podataka i upis u stablo
	{
		prefiks=0x00000000;
		duz=0;
		pomeraj=24;
		for(j=0;j<length;j++)
		{
			fscanf(fp,"%c", &c );
 			//citanje duzine prefiksa
			if((j==4)&&(podtip2==0x02)&&(podtip1==0x00)&&(tip1==0x00)&&(tip2==0x0D)){i=c;i=0x000000ff&i;duz=i;}
			//citanje samog prefiksa
			if((i>0)&&(podtip2==0x02)&&(podtip1==0x00)&&(tip1==0x00)&&(tip2==0x0D)&&(j>4))
			{
				x=c;
				if(i>8)
					i=i-8;
				else
					i=0;
				prefiks=prefiks|(x<<pomeraj);
				pomeraj=pomeraj-8;
			}
		}
		if(duz>32)//za proveru ispravnosti zapisa (ovo ne bi nikada trebalo da bude ispunjeno)
			duz=0;
		if(duz)//ispitivanje zapisa tj. prefiksa u njemu
		{
          x1=prefiks;
		  x2=duz;
		  if((x1!=x1pret)||(x2!=x2pret))//x1 pret i x2pret sadrze vrednost i duzinu prethodnog prefiksa
		  {
		    //u pitanju je novi prefiks
			x1pret=prefiks;
		    x2pret=duz;
			Nz++;//inkrementiranje ukupnog broja prefiksa
		  }
		  else
		  {
			//u pitanju je duplikat pa ga ne unosimo u stablo
		    x1pret=prefiks;
		    x2pret=duz;
		    duz=0;
		  }
		}
		if(duz)//upis novog prefiksa (u slucaju duplikata duz je postavljen na 0)
		{
			//unos prefiksa u binarno stablo
			i=0x80000000;
			tren=niz;
			if(x2>32)//opet za svaki slucaj jer ovo ne bi smelo da se desi
				k=0;
			k=0;
			while(x2)//dok se ne prodju svi biti prefiksa
			{
			  x2--;
			  j=i&x1;
			  x1=x1<<1;
			  if(j)//idi desno
			  {
			    if(tren->desno)
					tren=tren->desno;
				else//ako nema cvora kreiraj ga
				{
					novi=malloc(sizeof(stablo));
					novi->desno=NULL;
					novi->levo=NULL;
					novi->gore=tren;
					novi->level=tren->level+1;
					novi->nl=0;
					novi->nd=0;
					novi->pl=0;
					novi->pd=0;
					novi->dl=0;
					novi->dd=0;
					novi->prazan=1;
					k++;
					tren->desno=novi;
					tren=tren->desno;
				}
			  }
			  else//idi levo
			  {
			    if(tren->levo)
					tren=tren->levo;
				else//ako nema cvora kreiraj ga
				{
					novi=malloc(sizeof(stablo));
					novi->desno=NULL;
					novi->levo=NULL;
					novi->gore=tren;
					novi->level=tren->level+1;
					novi->nl=0;
					novi->nd=0;
					novi->pl=0;
					novi->pd=0;
					novi->dl=0;
					novi->dd=0;
					novi->prazan=1;
					k++;
					tren->levo=novi;
					tren=tren->levo;
				}
			  }
			}//end while x2
			tren->prazan=0;//tren pokazuje na cvor koji odgovara prefiksu pa za njega stavljamo da nije prazan
			j=k;
			while(j>1)// u ovoj while petlji azuriramo podatke roditelja koji su upravo bili kreirani za ovaj novododati prefiks poput broja dece, dubine naslednika i sl.
			{
				if((tren->gore->desno==tren)&&(tren->gore->dd<novi->level))tren->gore->dd=novi->level;
				if(tren->gore->desno==tren)tren->gore->pd++;
				if(tren->gore->desno==tren)tren->gore->nd+=(k-j+1);
				if((tren->gore->levo==tren)&&(tren->gore->dl<novi->level))tren->gore->dl=novi->level;
				if(tren->gore->levo==tren)tren->gore->pl++;
				if(tren->gore->levo==tren)tren->gore->nl+=(k-j+1);
				j--;
				tren=tren->gore;
			}//end while j
			while(tren->gore)// u ovoj while petlji azuriramo podatke roditelja koji su vec bili kreirani za ovaj novododati prefiks poput broja dece, dubine
			{
				if((tren->gore->desno==tren)&&(tren->gore->dd<novi->level))tren->gore->dd=novi->level;
				if(tren->gore->desno==tren)tren->gore->pd++;
				if(tren->gore->desno==tren)tren->gore->nd+=k;
				if((tren->gore->levo==tren)&&(tren->gore->dl<novi->level))tren->gore->dl=novi->level;
				if(tren->gore->levo==tren)tren->gore->pl++;
				if(tren->gore->levo==tren)tren->gore->nl+=k;
				tren=tren->gore;
			}

		}//end if duz
		if(total>=granica)break;//doslo se do kraja fajla
		//ucitavanje novih podataka
		fscanf(fp,"%c", &c );
		fscanf(fp,"%c", &c );
		fscanf(fp,"%c", &c );
		fscanf(fp,"%c", &c );
		fscanf(fp,"%c", &tip1 );
		fscanf(fp,"%c", &tip2 );
		fscanf(fp,"%c", &podtip1 );
		fscanf(fp,"%c", &podtip2 );
		fscanf(fp,"%c", &l1 );
		fscanf(fp,"%c", &l2 );
		fscanf(fp,"%c", &l3 );
		fscanf(fp,"%c", &l4 );

		length=l1;
		length=length<<8 | l2;
		length=length<<8 | l3;
		length=length<<8 | l4;
		total+=length;
		i=0;
	}//end while EOF
	fclose(fp);

void statistika (struct pokstablo *p) //funkcija koja daje broj list cvorove, broj simetricnih i asimetricnih list cvorova, broj cvorova po nivoima, broj cvorova sa podstablima iste dubine, broj cvorova sa potomcima u jednom ili oba podstabla
{
if (p->dd==p->dl) simdub++;
if ((p->nl==1)&&(p->nd==1)) simlist++;
if (((p->nl==1)&&(p->nd!=1))||((p->nd==1)&&(p->nl!=1))) asimlist++;
if (((p->nl==1)&&(p->desno==NULL))||((p->nd==1)&&(p->levo==NULL))) jedanlist++;
nivo[p->level]++;
if((p->desno!=NULL)&&(p->levo!=NULL)) simdeca++;
else if((p->desno!=NULL)||(p->levo!=NULL)) asimdeca++;
    else listdeca++;
if (p->levo!=NULL) statistika(p->levo);
if (p->desno!=NULL) statistika(p->desno);
}

simdub=0;
simlist=0;
asimlist=0;
simdeca=0;
asimdeca=0;
listdeca=0;
jedanlist=0;
for (i=1;i<=32;i++) nivo[i]=0;
statistika(niz);
bopt=0;
printf(" - Stanje pre transformacije -\n\n koren stabla \n prazan: %d\n dubina levo: %d, dubina desno: %d\n broj dece levo: %d, broj dece desno: %d\n broj pop. dece levo: %d, broj pop. dece desno: %d\n",niz->prazan,niz->dl,niz->dd,niz->nl,niz->nd,niz->pl,niz->pd);
printf(" broj cvorova sa simetricnom dubinom: %d\n simetricna deca: %d\n asimetricna deca: %d\n broj list-ova: %d\n broj cvorova sa simetricnim list-ovima: %d\n broj cvorova sa asimetricnim list-om: %d\n broj cvorova sa jednim list detetom: %d\n",simdub,simdeca,asimdeca,listdeca,simlist,asimlist,jedanlist);
printf(" broj cvorova po nivoima: \n");
for (i=1;i<=32;i++) printf(" nivo %d: %d\n",i,nivo[i]);

srand(time(NULL)); //generise novu random sekvencu brojeva

//transformacija
    while ((niz->nd)+(niz->nl)-(niz->pd)-(niz->pl)) //dok ima praznih cvorova radi optimizaciju
    {
    tren=niz;
    brpr=0; //broj praznih cvorovoa kroz koje smo prosli - minimalan uslov da neki cvor mozemo da premestimo je da u njegovoj putanji postoji barem jedan prazan cvor

    while((tren->desno)||(tren->levo)) //radi do list cvora
        {
        if (tren->prazan==1) brpr++; //brojac praznih cvorova u prolazu
        prazl=tren->nl-tren->pl;
        prazd=tren->nd-tren->pd;

        rndbr=rand()%2; //generise slucajan broj 0 ili 1

        if (brpr==0) //ukoliko nema praznih u prolazu
            {
            if ((prazl>0)&&(prazd>0))  //ako i levo i desno ima praznih nasumicno bira put
                {
                if (rndbr==0) tren=tren->levo;
                else tren=tren->desno;
                }
            else if (prazl>0) tren=tren->levo;   //ide gde ima praznih ako nema na obe strane
                else tren=tren->desno;
            }
        else if ((tren->nl>0)&&(tren->nd>0))  //ako ima cvorova i levo i desno ide nasumicno
            {
            if (rndbr==0) tren=tren->levo;
            else tren=tren->desno;
            }
            else if (tren->nl>0) tren=tren->levo;
                else tren=tren->desno;

        opt=tren;
        } //ovde nam je opt/tren tren cvor koji premestamo

bopt++; //inkrementiramo broj optimizacija

//brisanje cvorova i pomeranje cvora

no=0; //broj uklonjenih cvorova
while (tren->gore)
    {
    sled=tren->gore;
    if (tren->prazan==1) novi=tren; //nakon prolaska, novi ce biti prazan cvor najmanje dubine - za unos prefiksa
    if (niz->prazan==1) novi=niz; //uslov (tren->gore) petlje ne ispituje koren stabla

    if (((tren->desno==NULL)&&(tren->levo==NULL)&&(tren->prazan==1)&&(brpr>1))||(tren==opt)) //ako je u pitanju prazan cvor koji nema decu (u ovom slucaju je bitno da nije poslednji prazan cvor u putanji), ili ako je u pitanju cvor sa prefiksom koji se izmesta
        {
        no++;
        if (tren->prazan==1) brpr--;
        if (sled->desno==tren) //brise pokazivac sledeceg cvora na tren
            {
            sled->desno=NULL;
            sled->nd=0;
            sled->pd=0;
            ddd=sled->dd-no; // potrebno za azuriranje dubine u cvorovima
            sled->dd=0;
            }
        if(sled->levo==tren)
            {
            sled->levo=NULL;
            sled->nl=0;
            sled->pl=0;
            ddd=sled->dl-no;
            sled->dl=0;
            }
        free(tren);
        }
  //azuriranje ostalih cvorova
    else
    {
        if (sled->desno==tren)
        {
        sled->nd=sled->nd-no;
        sled->pd--;
        if (tren->dl>ddd) ddd=tren->dl;
        if (tren->dd>ddd) ddd=tren->dd;
        sled->dd=ddd;
        if (sled->dl>sled->dd) ddd=sled->dl;
        }
        if (sled->levo==tren)
        {
        sled->nl=sled->nl-no;
        sled->pl--;
        if (tren->dl>ddd) ddd=tren->dl;
        if (tren->dd>ddd) ddd=tren->dd;
        sled->dl=ddd;
        if (sled->dd>sled->dl) ddd=sled->dd;
        }
    }
    tren=sled; //kretanje na gore
    }

    novi->prazan=0; //unosenje prefiksa u novi cvor

    tren=novi;
    while (tren->gore) //azuriranje cvorova od unetog na gore
        {
        if (tren->gore->desno==tren)
            {
            tren->gore->pd++;
            }
            else tren->gore->pl++;
        tren=tren->gore;
        }

    }
izlaz:

simdub=0;
simlist=0;
asimlist=0;
simdeca=0;
asimdeca=0;
listdeca=0;
jedanlist=0;
for (i=1;i<=32;i++) nivo[i]=0;

statistika(niz);

printf("\n\n - Stanje nakon transformacije -\n\n koren stabla \n prazan: %d\n dubina levo: %d, dubina desno: %d\n broj dece levo: %d, broj dece desno: %d\n broj pop. dece levo: %d, broj pop. dece desno: %d\n",niz->prazan,niz->dl,niz->dd,niz->nl,niz->nd,niz->pl,niz->pd);
printf(" broj cvorova sa simetricnom dubinom: %d\n simetricna deca: %d\n asimetricna deca: %d\n broj list-ova: %d\n broj cvorova sa simetricnim list-ovima: %d\n broj cvorova sa asimetricnim list-om: %d\n broj cvorova sa jednim list detetom: %d\n",simdub,simdeca,asimdeca,listdeca,simlist,asimlist,jedanlist);
printf(" broj cvorova po nivoima: \n");
for (i=1;i<=32;i++) printf(" nivo %d: %d\n",i,nivo[i]);
printf(" broj optimizacija: %d\n",bopt);
}
